unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, lNetComponents, Forms, Controls, Graphics,
  Dialogs, StdCtrls, ExtCtrls, IniPropStorage, SdpoSerial, LCLIntf, LCLType,
  ComCtrls, channels, math, lNet, unit_robot;

type

  { TFMain }

  TFMain = class(TForm)
    BSetM0V: TButton;
    BOpenSerial: TButton;
    BCloseSerial: TButton;
    BSendRaw: TButton;
    BConfigSet: TButton;
    BSerialSend: TButton;
    BSetM0P: TButton;
    BSetM1V: TButton;
    BStopM0V: TButton;
    BStopM1V: TButton;
    BtCalibrationCheck: TButton;
    BtCalibrationStart: TButton;
    BtCalibrationStop: TButton;
    BtParametersReset: TButton;
    BtParametersSet: TButton;
    BtPath2: TButton;
    BtPath3: TButton;
    BtPath4: TButton;
    BtPath5: TButton;
    BtPath6: TButton;
    BUDPSend: TButton;
    BtDebugClear: TButton;
    BtPath1: TButton;
    CBComBlinkMute: TCheckBox;
    CbDebug: TCheckBox;
    CBRawDebug: TCheckBox;
    CBAutoOpen: TCheckBox;
    EdFLGainDist: TEdit;
    EdFLGainTh: TEdit;
    EdG2XYGainDec: TEdit;
    EdG2XYGainFwd: TEdit;
    EdRobotWhThRef: TEdit;
    EditBatVoltage: TEdit;
    EditBatVoltageRaw: TEdit;
    EditM1Pos: TEdit;
    EditM0PosRad: TEdit;
    EditM0Pos: TEdit;
    EditM0SetAcc: TEdit;
    EditM0SetPos: TEdit;
    EditM0Speed: TEdit;
    EditM1SpeedW: TEdit;
    EditM1SetAcc: TEdit;
    EditM0SetSpeed: TEdit;
    EditM1SetSpeed: TEdit;
    EditBatVoltageConv: TEdit;
    EditM1Speed: TEdit;
    EditSendChannel: TEdit;
    EditSendValue: TEdit;
    EditSerialName: TEdit;
    EditSendRaw: TEdit;
    EditBatVoltageTresh: TEdit;
    EditUDPPort: TEdit;
    EditUDPIP: TEdit;
    EditUDPSendPort: TEdit;
    EdMethodState: TEdit;
    EdParamPathDistDec: TEdit;
    EdParamPathDistNewPose: TEdit;
    EdParamPathHistEth: TEdit;
    EdParamPathMaxEth: TEdit;
    EdParamPathThDec: TEdit;
    EdParamPathThNewPose: TEdit;
    EdParamPathTolFinDist: TEdit;
    EdParamPathTolFinTh: TEdit;
    EdParamRobDvmax: TEdit;
    EdParamRobDwmax: TEdit;
    EdParamRobVdec: TEdit;
    EdParamRobVnom: TEdit;
    EdParamRobWdec: TEdit;
    EdParamRobWnom: TEdit;
    EdPath1: TEdit;
    EdPath2: TEdit;
    EdPath3: TEdit;
    EdPath4: TEdit;
    EdPrimaryState: TEdit;
    EdRobotTh: TEdit;
    EdRobotV: TEdit;
    EdRobotW: TEdit;
    EdRobotWhTh: TEdit;
    EdRobotWhWRef: TEdit;
    EdRobotWhWCtrl: TEdit;
    EdRobotWhTk: TEdit;
    EdRobotWhW: TEdit;
    EdRobotX: TEdit;
    EdRobotY: TEdit;
    EdRunIndex: TEdit;
    EdSegmentIndex: TEdit;
    GbExecutionInfo: TGroupBox;
    GbInfo: TGroupBox;
    GbManualControlM1: TGroupBox;
    GbParametersPathAlgorithms: TGroupBox;
    GbParametersPathFL: TGroupBox;
    GbParametersPathG2XY: TGroupBox;
    GbParametersRobot: TGroupBox;
    GroupBox1: TGroupBox;
    GbManualControl: TGroupBox;
    GbManualControlM0: TGroupBox;
    GbRobotInfo: TGroupBox;
    IniPropStorage: TIniPropStorage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    LbRobotWhWCtrl: TLabel;
    LbRobotWhWRef: TLabel;
    LbRobotWhThRef: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LbFLGainDist: TLabel;
    LbFLGainTh: TLabel;
    LbG2XYGainDec: TLabel;
    LbG2XYGainFwd: TLabel;
    LbMethodState: TLabel;
    LbParamPathDistDec: TLabel;
    LbParamPathDistNewPose: TLabel;
    LbParamPathHistEth: TLabel;
    LbParamPathMaxEth: TLabel;
    LbParamPathThDec: TLabel;
    LbParamPathThNewPose: TLabel;
    LbParamPathTolFinDist: TLabel;
    LbParamPathTolFinTh: TLabel;
    LbParamRobDvmax: TLabel;
    LbParamRobDwmax: TLabel;
    LbParamRobVdec: TLabel;
    LbParamRobVnom: TLabel;
    LbParamRobWdec: TLabel;
    LbParamRobWnom: TLabel;
    LbPath1: TLabel;
    LbPath2: TLabel;
    LbPath3: TLabel;
    LbPath4: TLabel;
    LbPrimaryState: TLabel;
    LbRobotTh: TLabel;
    LbRobotV: TLabel;
    LbRobotW: TLabel;
    LbRobotW1: TLabel;
    LbRobotWhTh: TLabel;
    LbRobotWhTk: TLabel;
    LbRobotX: TLabel;
    LbRobotY: TLabel;
    LbRunIndex: TLabel;
    LbSegmentIndex: TLabel;
    MmDebug: TMemo;
    PcCalibration: TPageControl;
    RbPathFree: TRadioButton;
    RbPathCircular: TRadioButton;
    RbPathSquare: TRadioButton;
    RgPathType: TRadioGroup;
    ShapeComBlink: TShape;
    ShapeUDPState: TShape;
    ShState: TShape;
    TabData: TTabSheet;
    TabSheet1: TTabSheet;
    TbM0PosCtrlState: TToggleBox;
    TbTypeM0V: TToggleBox;
    TbTypeM1V: TToggleBox;
    TimerCtrl: TTimer;
    TsOdometryCalibration: TTabSheet;
    TsParameters: TTabSheet;
    UDP: TLUDPComponent;
    MemoDebug: TMemo;
    PageControl: TPageControl;
    Serial: TSdpoSerial;
    ShapeSerialState: TShape;
    StatusBar: TStatusBar;
    TabDebug: TTabSheet;
    TabConfig: TTabSheet;
    procedure BCloseSerialClick(Sender: TObject);
    procedure BConfigSetClick(Sender: TObject);
    procedure BSetM0PClick(Sender: TObject);
    procedure BSetM0VClick(Sender: TObject);
    procedure BOpenSerialClick(Sender: TObject);
    procedure BSendRawClick(Sender: TObject);
    procedure BSetM1VClick(Sender: TObject);
    procedure BStopM0VClick(Sender: TObject);
    procedure BStopM1VClick(Sender: TObject);
    procedure BtCalibrationCheckClick(Sender: TObject);
    procedure BtCalibrationStartClick(Sender: TObject);
    procedure BtCalibrationStopClick(Sender: TObject);
    procedure BtDebugClearClick(Sender: TObject);
    procedure BtPath1Click(Sender: TObject);
    procedure BtPath2Click(Sender: TObject);
    procedure BtPath3Click(Sender: TObject);
    procedure BtPath4Click(Sender: TObject);
    procedure BtPath5Click(Sender: TObject);
    procedure BtPath6Click(Sender: TObject);
    procedure BUDPSendClick(Sender: TObject);
    procedure EditSendRawKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RbPathCircularChange(Sender: TObject);
    procedure RbPathFreeChange(Sender: TObject);
    procedure RbPathSquareChange(Sender: TObject);
    procedure SerialRxData(Sender: TObject);
    procedure TbM0PosCtrlStateChange(Sender: TObject);
    procedure TbTypeM0VChange(Sender: TObject);
    procedure TbTypeM1VChange(Sender: TObject);
    procedure TimerCtrlTimer(Sender: TObject);
    procedure UDPReceive(aSocket: TLSocket);
    procedure BtParametersResetClick(Sender: TObject);
    procedure BtParametersSetClick(Sender: TObject);
  private
    procedure Debug(Memo: TMemo; s: string);
    procedure processFrame(channel: char; value: integer; source: integer);
    procedure SendUDPChannel(c: char; val: integer);
    procedure ShowSerialState;
    procedure ShowUDPState;
    { private declarations }
  public
    BatVoltageTresh, BatVoltageConv: double;
    SerialChannels, UDPChannels: TChannels;
    BatVoltage: double;
    BatVoltageRaw: integer;
    dir_angle: double;
    M0ActSpeed: double;

    procedure SendMessage(c: char; val: integer);

  { >>>>> ODOMETRY CALIBRATION <<<<< }

  public
    // GUI
    procedure UpdateGUI;
    procedure resetPathFields;
    procedure enablePathCircularFields;
    procedure enablePathSquareFields;
    procedure enablePathFreeFields; 
    // Odometry calibration
    procedure odometryCalibration(xodo,yodo,thodo: double; out v, w: double);
    procedure followPathCircular(xodo,yodo,thodo: double; out v, w: double);
    procedure followPathSquare(xodo,yodo,thodo: double; out v, w: double);
    procedure followPathFree(xodo,yodo,thodo: double; out v, w: double);
    // Algorithms for Path Following
    procedure updatePathAlgorithmsParameters;
    procedure distanceToLine(x, y, tr, xi, yi, xf, yf: double; out distLine, testSideLine, nearX, nearY: double);
    function  dist(x, y: double): double;
    procedure gotoXY(x, y, th, xf, yf, thf: double; out v, w: double);
    procedure followLine(x, y, th, xi, yi, xf, yf, thf: double; out v, w: double);

  private
    globalTimeStamp: Double;
    // Algorithms for Path Following
    state_gotoXY, state_followLine: integer;      // States Machine
    MAX_ETH, HIST_ETH: double;                    // Go forward
    TOL_FINDIST, TOL_FINTH: double;               // Final pose
    DIST_DEC, TH_DEC: double;                     // Deceleration
    DIST_NEWPOSE, TH_NEWPOSE: double;             // New pose
    GAIN_FWD, GAIN_DA: double;                    // GoToXY: gain go forward
    GAIN_DIST, GAIN_TH: double;                   // FollowLine: gain follow line
    V_NOM, V_DEC, DVMAX, W_NOM, W_DEC, DWMAX: double; // Robot velocities
    // Odometry Calibration Algorithm
    // - data file output
    tfDataOut: TextFile;
    // - auxiliar variables for circular paths
    V_NOM_CIRC, V_DEC_CIRC, W_NOM_CIRC, W_DEC_CIRC: double;
    // - displacements for circular paths
    deltaD_segment, deltaTh_segment: double;
    // - indexes
    irun, isegment, istabilise: integer;
    // - boolean conditions
    robot_stopped, start_method, stop_method, check_run, finish_method: boolean;
    // - state Machines
    state_calibration, state_method: integer;
    // - key pressed handled
    V_FREE,W_FREE: Double;

  end;

const
  // GoToXY: states
  GO2XY_ROTINI = 0;
  GO2XY_FWD = 1;
  GO2XY_FWDDEC = 2;
  GO2XY_ROTFIN = 3;
  GO2XY_ROTFINDEC = 4;
  GO2XY_STOP = 5;
  // Follow Line: states
  FL_GO2INIT = 0;
  FL_NEWLINE = 1;
  FL_FOLLOWLINE = 2;
  FL_APPROACH = 3;
  FL_EMERGENCY = 4;
  FL_STOP = 5;
  // Memo messages
  MAX_MESSAGES_DEBUG = 5;

var
  FMain: TFMain;


implementation

{$R *.lfm}

{ TFMain }


procedure TFMain.ShowUDPState;
begin
  if UDP.Connected then begin
    ShapeUDPState.Brush.Color := clGreen;
  end else begin
    ShapeUDPState.Brush.Color := clRed;
  end;
end;


procedure TFMain.ShowSerialState;
begin
  if Serial.Active then begin
    ShapeSerialState.Brush.Color := clGreen;
  end else begin
    ShapeSerialState.Brush.Color := clRed;
  end;
end;

procedure TFMain.SendMessage(c: char; val: integer);
begin
  Serial.WriteData(c + IntToHex(dword(Val), 8));
end;


procedure TFMain.SendUDPChannel(c: char; val: integer);
var addr: string;
begin
  addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
  UDP.SendMessage(c + IntToHex(dword(Val), 8), addr);
end;

procedure TFMain.BOpenSerialClick(Sender: TObject);
begin
  Serial.Device := EditSerialName.Text;
  Serial.Open;
  ShowSerialState();
end;


procedure TFMain.BSendRawClick(Sender: TObject);
var addr: string;
begin
  if Serial.Active then Serial.WriteData(EditSendRaw.Text);
  if UDP.Active then begin
    addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
    UDP.SendMessage(EditSendRaw.Text, addr);
  end;

end;

procedure TFMain.BtDebugClearClick(Sender: TObject);
begin
  MemoDebug.Clear;
end;

procedure TFMain.BtPath1Click(Sender: TObject);
begin
  V_FREE := V_FREE + 0.005;
end;

procedure TFMain.BtPath2Click(Sender: TObject);
begin
  V_FREE := V_FREE - 0.005;
end;

procedure TFMain.BtPath3Click(Sender: TObject);
begin
  W_FREE := W_FREE + 0.005;
end;

procedure TFMain.BtPath4Click(Sender: TObject);
begin
  W_FREE := W_FREE - 0.005;
end;

procedure TFMain.BtPath5Click(Sender: TObject);
begin
  V_FREE := 0;
end;

procedure TFMain.BtPath6Click(Sender: TObject);
begin
  W_FREE := 0;
end;

procedure TFMain.BUDPSendClick(Sender: TObject);
var s: string;
  v: integer;
begin
  s := EditSendChannel.Text;
  if s <> '' then begin
    v := StrToIntDef(EditSendValue.Text, 0);
    SendUDPChannel(s[1], v);
  end;
end;

procedure TFMain.EditSendRawKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then begin
    BSendRaw.Click();
  end;
end;

procedure TFMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Serial.Close;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  DefaultFormatSettings.DecimalSeparator := '.';
  SerialChannels := TChannels.Create(@processFrame);
  UDPChannels := TChannels.Create(@processFrame);
  // Path types
  RbPathCircular.Checked := True;
  // Robot structure
  RobotInit;
end;

procedure TFMain.FormShow(Sender: TObject);
var port: integer;
begin
  ShowSerialState();
  BConfigSet.Click();
  if CBAutoOpen.Checked then BOpenSerial.Click();

  port := StrToIntDef(EditUDPPort.Text, 9632);
  UDP.Listen(port);
  EditUDPPort.Text := IntToStr(port);
  ShowUDPState();
end;

procedure TFMain.RbPathCircularChange(Sender: TObject);
begin
  if (RbPathCircular.Checked) then
  begin
    resetPathFields;
    enablePathCircularFields;
  end;
end;

procedure TFMain.RbPathFreeChange(Sender: TObject);
begin
  if (RbPathFree.Checked) then
  begin
    resetPathFields;
    enablePathFreeFields;
  end;
end;

procedure TFMain.RbPathSquareChange(Sender: TObject);
begin
  if (RbPathSquare.Checked) then
  begin
    resetPathFields;
    enablePathSquareFields;
  end;
end;

procedure TFMain.FormDestroy(Sender: TObject);
begin
  if (state_calibration <> 0) then
  begin
    CloseFile(tfDataOut);
  end;
  UDPChannels.Free;
  SerialChannels.Free;
end;



procedure TFMain.Debug(Memo: TMemo; s: string);
begin
  Memo.Text := Memo.Text + s;
  Memo.SelStart:=Length(Memo.Text);
  while Memo.Lines.Count > 1000 do begin
    Memo.Lines.Delete(0);
  end;
end;


procedure TFMain.SerialRxData(Sender: TObject);
var s: string;
begin
  s := Serial.ReadData;
  if s = '' then exit;

  SerialChannels.ReceiveData(s);

  if CBRawDebug.Checked then begin
    Debug(MemoDebug,s);
  end;
end;

procedure TFMain.TbM0PosCtrlStateChange(Sender: TObject);
begin
  if (TbM0PosCtrlState.State = cbUnchecked) then begin
    TbM0PosCtrlState.Caption := 'Reset';
  end else if (TbM0PosCtrlState.State = cbChecked) then begin
    TbM0PosCtrlState.Caption := 'PosCtrl';
  end;
end;

procedure TFMain.TbTypeM0VChange(Sender: TObject);
begin
  if (TbTypeM0V.State = cbUnchecked) then begin
    TbTypeM0V.Caption := '(steps/cycle)';
  end else if (TbTypeM0V.State = cbChecked) then begin
    TbTypeM0V.Caption := '(rad/s)';
  end;
end;

procedure TFMain.TbTypeM1VChange(Sender: TObject);
begin
  if (TbTypeM1V.State = cbUnchecked) then begin
    TbTypeM1V.Caption := '(steps/cycle)';
  end else if (TbTypeM1V.State = cbChecked) then begin
    TbTypeM1V.Caption := '(rad/s)';
  end;
end;



procedure TFMain.UDPReceive(aSocket: TLSocket);
var msg: string;
begin
  UDP.GetMessage(msg);
  if msg = '' then exit;
  UDPChannels.ReceiveData(msg);
  if CBRawDebug.Checked then begin
    Debug(MemoDebug,msg);
  end;
end;

procedure TFMain.BCloseSerialClick(Sender: TObject);
begin
  Serial.Close;
  ShowSerialState();
end;

procedure TFMain.BConfigSetClick(Sender: TObject);
begin
  BatVoltageConv := StrToFloat(EditBatVoltageConv.Text);
  BatVoltageTresh := StrToFloat(EditBatVoltageTresh.Text);
end;

procedure TFMain.BSetM0PClick(Sender: TObject);
var M0Pos: integer;
    msg, addr: string;
begin
  M0Pos := PosAngularToPosSteps(DegToRad(StrToFloat(EditM0SetPos.Text)),0);
  addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
  if (TbM0PosCtrlState.State = cbChecked) then begin
    msg := 'P' + '00' + '01' + IntToHex(word(M0Pos), 4);
    robot.M0.th_ref := DegToRad(StrToFloat(EditM0SetPos.Text));
  end else begin
    msg := 'P' + '00' + '00' + IntToHex(word(M0Pos), 4);
    robot.M0.th := DegToRad(StrToFloat(EditM0SetPos.Text));
  end;
  UDP.SendMessage(msg, addr);
end;

procedure TFMain.BSetM0VClick(Sender: TObject);
var M0Speed: integer;
    M0Acc: integer;
    msg, addr: string;
begin
  if (TbTypeM0V.State = cbUnchecked) then begin
    M0Speed := StrToIntDef(EditM0SetSpeed.Text, 0);
  end else begin
    M0Speed := SpeedAngularToSpeedSteps(StrToFloatDef(EditM0SetSpeed.Text, 0),0);
  end;
  M0Acc         := StrToIntDef(EditM0SetAcc.Text, 100);
  robot.M0.acel := M0Acc;
  addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
  msg := 'S' + '00' + IntToHex(byte(M0Acc), 2) + IntToHex(word(M0Speed), 4);
  UDP.SendMessage(msg, addr);
end;

procedure TFMain.BStopM0VClick(Sender: TObject);
var M0Speed: integer;
    M0Acc: integer;
    msg, addr: string;
begin
  M0Speed := 0;
  M0Acc := 255;
  robot.M0.acel  := 255;
  addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
  msg := 'S' + '00' + IntToHex(byte(M0Acc), 2) + IntToHex(word(M0Speed), 4);
  UDP.SendMessage(msg, addr);
end;

procedure TFMain.BSetM1VClick(Sender: TObject);
var M1Speed: integer;
    M1Acc: integer;
    msg, addr: string;
begin
  if (TbTypeM1V.State = cbUnchecked) then begin
    M1Speed := StrToIntDef(EditM1SetSpeed.Text, 0);
    robot.M1.w_ref := SpeedStepsToSpeedAngular(StrToIntDef(EditM1SetSpeed.Text, 0), 1);
  end else begin
    M1Speed := SpeedAngularToSpeedSteps(StrToFloatDef(EditM1SetSpeed.Text, 0), 1);
    robot.M1.w_ref := StrToFloatDef(EditM1SetSpeed.Text, 0);
  end;
  M1Acc         := StrToIntDef(EditM1SetAcc.Text, 100);
  robot.M1.acel := M1Acc;
  addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
  msg := 'S' + '01' + IntToHex(byte(M1Acc), 2) + IntToHex(word(M1Speed), 4);
  UDP.SendMessage(msg, addr);
end;

procedure TFMain.BStopM1VClick(Sender: TObject);
var M1Speed: integer;
    M1Acc: integer;
    msg, addr: string;
begin
  M1Speed := 0;
  M1Acc := 255;
  addr := EditUDPIP.Text + ':' + EditUDPSendPort.Text;
  msg := 'S' + '01' + IntToHex(byte(M1Acc), 2) + IntToHex(word(M1Speed), 4);
  UDP.SendMessage(msg, addr);
end;

procedure TFMain.BtCalibrationCheckClick(Sender: TObject);
begin
  if ((state_calibration <> 0) and (not check_run)) then begin
    check_run := True;
  end;
end;

procedure TFMain.BtCalibrationStartClick(Sender: TObject);
begin
  if ((state_calibration = 0) and (not start_method)) then begin
    start_method := True;
  end;
end;

procedure TFMain.BtCalibrationStopClick(Sender: TObject);
begin
  if (not stop_method) then begin
    stop_method := True;
  end;
end;


procedure TFMain.processFrame(channel: char; value: integer; source: integer);
var i: integer;
    s: string;
begin
  if channel = 'i' then begin
  //end else if channel = 'r' then begin
    // if the arduino was reset ...
  end else if channel = 'V' then begin                 // Battery voltage
    BatVoltageRaw := value;
    BatVoltage := value * BatVoltageConv;
    EditBatVoltageRaw.Text := format('%d', [BatVoltageRaw]);
    EditBatVoltage.Text := format('%.2f', [BatVoltage]);
    // Check connection (when unmuted)
    if not CBComBlinkMute.Checked then begin
      if ShapeComBlink.Brush.Color <> clGreen then begin
        ShapeComBlink.Brush.Color := clGreen;
      end else begin
        ShapeComBlink.Brush.Color := clLime;
      end;
    end;
  end else if channel = 'M' then begin                 // M0 speed
    M0ActSpeed        := value;
    EditM0Speed.Text  := format('%d', [value]);
  end else if channel = 'N' then begin                 // M1 speed
    EditM1Speed.Text  := format('%d', [value]);
  end else if channel = 'P' then begin                 // M0 position
    robot.M0.steps := value;
    robot.M0.th    := PosStepsToPosAngular(value,0);
  end else if channel = 'Q' then begin
    robot.M1.steps := UInt16(robot.M1.steps + value);
    EditM1Pos.Text := format('%d', [robot.M1.steps]);
    //UDP.SendMessage('P' + '01' + '00' + IntToHex(word(0), 4), EditUDPIP.Text + ':' + EditUDPSendPort.Text);
  end else if channel in ['s', 't'] then begin
    i := 1 + ord(channel) - ord('r');
  end;
end;





procedure TFMain.TimerCtrlTimer(Sender: TObject);
var v,w:double;
    M0Pos,M1Speed: Integer;
    msg: String;
begin
  globalTimeStamp := globalTimeStamp + TimerCtrl.Interval/1000;

  // Update Odometry
  UpdateOdometry(0.050);

  // Odometry Calibration
  odometryCalibration(robot.pos.x,robot.pos.y,robot.pos.th,v,w);

  // Inverse Kinematics
  InverseKinematics(v,w);
  {if (CbDebug.Checked) then begin
    Debug(MmDebug,format('V%.4fW%.4f',[v,w]));
  end;}

  // Send commands to the robot   if (TbTypeM0V.State = cbUnchecked) then begin
  if (state_calibration <> 0) then begin
    M1Speed := SpeedAngularToSpeedSteps(robot.M1.w_ctrl,1);
    M0Pos   := PosAngularToPosSteps(robot.M0.th_ref,0);
    msg := 'P' + '00' + '01' + IntToHex(word(M0Pos), 4);
    UDP.SendMessage(msg, EditUDPIP.Text + ':' + EditUDPSendPort.Text);
    msg := 'S' + '01' + IntToHex(byte(robot.M1.acel), 2) + IntToHex(word(M1Speed), 4);
    UDP.SendMessage(msg, EditUDPIP.Text + ':' + EditUDPSendPort.Text);
  end;

  // Update GUI
  UpdateGUI;
end;

procedure TFMain.UpdateGUI;
begin
  EditM0Pos.Text    := format('%d'  , [robot.M0.steps]);
  EditM0PosRad.Text := format('%.2f', [RadToDeg(robot.M0.th)]);
  EditM1SpeedW.Text := format('%.4f', [robot.M1.w]);
  // Odometry Calibration
  EdRobotX.Text  := format('%.4f', [robot.pos.x]);
  EdRobotY.Text  := format('%.4f', [robot.pos.y]);
  EdRobotTh.Text := format('%.2f', [RadToDeg(robot.pos.th)]);
  EdRobotWhTk.Text := format('%d'  , [robot.M1.deltaSteps]);
  EdRobotWhTh.Text := format('%.2f', [RadToDeg(robot.M0.th)]);
  EdRobotWhW.Text := format('%.4f', [robot.M1.w]);
  EdRobotV.Text := format('%.4f', [robot.vel.v]);
  EdRobotW.Text := format('%.4f', [robot.vel.w]);
  // Inverse Kinematics
  EdRobotWhThRef.Text := format('%.4f', [RadToDeg(robot.M0.th_ref)]);
  EdRobotWhWRef.Text  := format('%.4f', [robot.M1.w_ref]);
  EdRobotWhWCtrl.Text := format('%.4f', [robot.M1.w_ctrl]);
end;

procedure TFMain.resetPathFields;
begin
  LbPath1.Visible := False; LbPath1.Enabled := False; EdPath1.Visible := False; EdPath1.Enabled := False;
  LbPath2.Visible := False; LbPath2.Enabled := False; EdPath2.Visible := False; EdPath2.Enabled := False;
  LbPath3.Visible := False; LbPath3.Enabled := False; EdPath3.Visible := False; EdPath3.Enabled := False;
  LbPath4.Visible := False; LbPath4.Enabled := False; EdPath4.Visible := False; EdPath4.Enabled := False;
  BtPath1.Visible := False; BtPath1.Enabled := False;
  BtPath2.Visible := False; BtPath2.Enabled := False;
  BtPath3.Visible := False; BtPath3.Enabled := False;
  BtPath4.Visible := False; BtPath4.Enabled := False;
  BtPath5.Visible := False; BtPath5.Enabled := False;
  BtPath6.Visible := False; BtPath6.Enabled := False;
end;

procedure TFMain.enablePathCircularFields;
begin
  LbPath1.Caption := 'N:';     LbPath1.Visible := True; LbPath1.Enabled := True; EdPath1.Visible := True; EdPath1.Enabled := True;
  LbPath2.Caption := 'R:';     LbPath2.Visible := True; LbPath2.Enabled := True; EdPath2.Visible := True; EdPath2.Enabled := True;
  LbPath3.Caption := 'dec%:';  LbPath3.Visible := True; LbPath3.Enabled := True; EdPath3.Visible := True; EdPath3.Enabled := True;
  LbPath4.Caption := '180º:';  LbPath4.Visible := True; LbPath4.Enabled := True; EdPath4.Visible := True; EdPath4.Enabled := True;
end;

procedure TFMain.enablePathSquareFields;
begin
  LbPath1.Caption := 'N:'; LbPath1.Visible := True; LbPath1.Enabled := True; EdPath1.Visible := True; EdPath1.Enabled := True;
  LbPath2.Caption := 'L:'; LbPath2.Visible := True; LbPath2.Enabled := True; EdPath2.Visible := True; EdPath2.Enabled := True;
end;

procedure TFMain.enablePathFreeFields;
begin
  LbPath1.Caption := 'N:'; LbPath1.Visible := True; LbPath1.Enabled := True; EdPath1.Visible := True; EdPath1.Enabled := True;
  LbPath2.Caption := 'v:'; LbPath2.Visible := True; LbPath2.Enabled := True; EdPath2.Visible := True; EdPath2.Enabled := False;
  LbPath3.Caption := 'w:'; LbPath3.Visible := True; LbPath3.Enabled := True; EdPath3.Visible := True; EdPath3.Enabled := False;
  BtPath1.Visible := True; BtPath1.Enabled := True;
  BtPath2.Visible := True; BtPath2.Enabled := True;
  BtPath3.Visible := True; BtPath3.Enabled := True;
  BtPath4.Visible := True; BtPath4.Enabled := True;
  BtPath5.Visible := True; BtPath5.Enabled := True;
  BtPath6.Visible := True; BtPath6.Enabled := True;
end;



{ >>>>> ODOMETRY CALIBRATION <<<<< }

procedure TFMain.BtParametersResetClick(Sender: TObject);
begin
  // Velocity parameters
  V_NOM := 0.05;
  V_DEC := 0.035;
  DVMAX := 0.001;
  W_NOM := 0.5;
  W_DEC := 0.35;
  DWMAX := 0.005;
  // Path Algorithms
  MAX_ETH := 5.0;
  HIST_ETH := 5.0;
  TOL_FINDIST := 0.05;
  TOL_FINTH := 5.0;
  DIST_DEC := 0.1;
  TH_DEC := 30.0;
  DIST_NEWPOSE := 0.15;
  TH_NEWPOSE := 35.0;
  // - GoToXY:
  GAIN_FWD := 0.05;
  GAIN_DA := 0.075;
  // - FollowLine:
  GAIN_DIST := 10.0;
  GAIN_TH := 0.4;

  updatePathAlgorithmsParameters;
end;

procedure TFMain.BtParametersSetClick(Sender: TObject);
begin
  try
    // Velocity parameters
    V_NOM := StrToFloat(EdParamRobVnom.Text);
    V_DEC := StrToFloat(EdParamRobVdec.Text);
    DVMAX := StrToFloat(EdParamRobDvmax.Text);
    W_NOM := StrToFloat(EdParamRobWnom.Text);
    W_DEC := StrToFloat(EdParamRobWdec.Text);
    DWMAX := StrToFloat(EdParamRobDwmax.Text);
    // Path Algorithms
    MAX_ETH  := StrToFloat(EdParamPathMaxEth.Text);
    HIST_ETH := StrToFloat(EdParamPathHistEth.Text);
    TOL_FINDIST := StrToFloat(EdParamPathTolFinDist.Text);
    TOL_FINTH   := StrToFloat(EdParamPathTolFinTh.Text);
    DIST_DEC := StrToFloat(EdParamPathDistDec.Text);
    TH_DEC   := StrToFloat(EdParamPathThDec.Text);
    DIST_NEWPOSE := StrToFloat(EdParamPathDistNewPose.Text);
    TH_NEWPOSE   := StrToFloat(EdParamPathThNewPose.Text);
    // - GoToXY:
    GAIN_FWD := StrToFloat(EdG2XYGainFwd.Text);
    GAIN_DA  := StrToFloat(EdG2XYGainDec.Text);
    // - FollowLine:
    GAIN_DIST := StrToFloat(EdFLGainDist.Text);
    GAIN_TH   := StrToFloat(EdFLGainTh.Text);
  finally
  end;
end;

procedure TFMain.updatePathAlgorithmsParameters;
begin
  try
    // Velocity parameters
    EdParamRobVnom.Text := Format('%g', [V_NOM]);
    EdParamRobVdec.Text := Format('%g', [V_DEC]);
    EdParamRobDvmax.Text := Format('%g', [DVMAX]);
    EdParamRobWnom.Text := Format('%g', [W_NOM]);
    EdParamRobWdec.Text := Format('%g', [W_DEC]);
    EdParamRobDwmax.Text := Format('%g', [DWMAX]);
    // Path Algorithms
    EdParamPathMaxEth.Text := Format('%g', [MAX_ETH]);
    EdParamPathHistEth.Text := Format('%g', [HIST_ETH]);
    EdParamPathTolFinDist.Text := Format('%g', [TOL_FINDIST]);
    EdParamPathTolFinTh.Text := Format('%g', [TOL_FINTH]);
    EdParamPathDistDec.Text := Format('%g', [DIST_DEC]);
    EdParamPathThDec.Text := Format('%g', [TH_DEC]);
    EdParamPathDistNewPose.Text := Format('%g', [DIST_NEWPOSE]);
    EdParamPathThNewPose.Text := Format('%g', [TH_NEWPOSE]);
    // - GoToXY:
    EdG2XYGainFwd.Text := Format('%g', [GAIN_FWD]);
    EdG2XYGainDec.Text := Format('%g', [GAIN_DA]);
    // - FollowLine:
    EdFLGainDist.Text := Format('%g', [GAIN_DIST]);
    EdFLGainTh.Text := Format('%g', [GAIN_TH]);
  finally
  end;
end;

procedure TFMain.distanceToLine(x, y, tr, xi, yi, xf, yf: double; out distLine, testSideLine, nearX, nearY: double);
var
  part1, part2: double;
begin
  part1 := ((xi - x) * sin(tr) * sin(tr) - (yi - y) * 0.5 * sin(2 * tr));
  part2 := ((yi - y) * cos(tr) * cos(tr) - (xi - x) * 0.5 * sin(2 * tr));
  distLine := sqrt(part1 * part1 + part2 * part2);
  testSideLine := -sign(sin(tr - arctan2(part2, part1)));
  nearX := x + part1;
  nearY := y + part2;
end;

function TFMain.dist(x, y: double): double;
begin
  dist := sqrt(sqr(x) + sqr(y));
end;

procedure TFMain.gotoXY(x, y, th, xf, yf, thf: double; out v, w: double);
const
  // Fastest rotations
  ROTATERIGHT = 1;
  ROTATELEFT = -1;
var
  rotateTo, rotateToFinal: double;
  tht, error_dist, error_th, error_thf: double;
begin
  // Compute errors
  tht := arctan2(yf - y, xf - x);
  error_th := normalizeAngle(tht - th);
  error_dist := dist(xf - x, yf - y);
  error_thf := normalizeAngle(thf - th);
  // Fastest rotations
  if (error_th > 0) then begin  rotateTo := ROTATERIGHT;
  end else begin                rotateTo := ROTATELEFT;  end;
  if (error_thf > 0) then begin rotateToFinal := ROTATERIGHT;
  end else begin                rotateToFinal := ROTATELEFT;  end;

  // Transitions
  case state_gotoXY of
    GO2XY_ROTINI: begin                      // INITIAL ROTATION
      if (abs(error_th) < DegToRad(MAX_ETH)) then begin
        state_gotoXY := GO2XY_FWD;           //                  >>> GO FORWARD
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Initial rotation > Go forward');
        end;
      end else if (error_dist < TOL_FINDIST) then begin
        state_gotoXY := GO2XY_ROTFIN;        //                  >>> FINAL ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Initial rotation > Final rotation');
        end;
      end;
    end;
    GO2XY_FWD: begin                         // GO FORWARD
      if (error_dist < TOL_FINDIST) then begin
        state_gotoXY := GO2XY_ROTFIN;        //            >>> FINAL ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Go forward > Final rotation');
        end;
      end else if (error_dist < DIST_DEC) then begin
        state_gotoXY := GO2XY_FWDDEC;        //            >>> GO FORWARD DECELERATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Go forward > Deceleration');
        end;
      end else if (abs(error_th) > DegToRad(MAX_ETH + HIST_ETH)) then begin
        state_gotoXY := GO2XY_ROTINI;        //            >>> INITIAL ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Go forward > Initial rotation');
        end;
      end;
    end;
    GO2XY_FWDDEC: begin                      // GO FORWARD DECELERATION
      if (error_dist < TOL_FINDIST) then begin
        state_gotoXY := GO2XY_ROTFIN;        //                         >>> FINAL ROTATION 
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Deceleration > Final rotation');
        end;
      end else if (error_dist > DIST_NEWPOSE) then begin
        state_gotoXY := GO2XY_ROTINI;        //                         >>> INITIAL ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Deceleration > Initial rotation');
        end;
      end;
    end;
    GO2XY_ROTFIN: begin                      // FINAL ROTATION
      if (abs(error_thf) < DegToRad(TH_DEC)) then begin
        state_gotoXY := GO2XY_ROTFINDEC;     //                >>> FINAL ROTATION DECELERATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Final rotation > Final rotation deceleration');
        end;
      end else if (error_dist > DIST_NEWPOSE) then begin
        state_gotoXY := GO2XY_ROTINI;        //                >>> INITIAL ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Final rotation > Initial rotation');
        end;
      end;
    end;
    GO2XY_ROTFINDEC: begin                   // FINAL ROTATION DECELERATION
      if (abs(error_thf) < DegToRad(TOL_FINTH)) then begin
        state_gotoXY := GO2XY_STOP;          //                             >>> STOP
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Final rotation deceleration > Stop');
        end;
      end else if ((error_dist > DIST_NEWPOSE) or (abs(error_thf) > DegToRad(TH_NEWPOSE))) then begin
        state_gotoXY := GO2XY_ROTINI;        //                             >>> INITIAL ROTATION 
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Final rotation deceleration > Initial rotation');
        end;
      end;
    end;
    GO2XY_STOP: begin                        // STOP
      if ((error_dist > DIST_NEWPOSE) or (abs(error_thf) > DegToRad(TH_NEWPOSE))) then begin
        state_gotoXY := GO2XY_ROTINI;        //      >>> INITIAL ROTATION 
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[G2XY] Stop > Initial rotation');
        end;
      end;
    end;
  end;

  // Output
  case state_gotoXY of
    GO2XY_ROTINI: begin                      // INITIAL ROTATION
      v := 0;
      w := rotateTo * W_NOM;
    end;
    GO2XY_FWD: begin                         // GO FORWARD
      v := V_NOM;
      w := GAIN_FWD * error_th;
    end;
    GO2XY_FWDDEC: begin                      // GO FORWARD DECELERATION
      v := V_DEC;
      w := GAIN_DA * error_th;
    end;
    GO2XY_ROTFIN: begin                      // FINAL ROTATION
      v := 0;
      w := rotateToFinal * W_NOM;
    end;
    GO2XY_ROTFINDEC: begin                   // FINAL ROTATION DECELERATION
      v := 0;
      w := rotateToFinal * W_DEC;
    end;
    GO2XY_STOP: begin                        // STOP
      v := 0;
      w := 0;
      StopRobot;
    end;
  end;
end;

procedure TFMain.followLine(x, y, th, xi, yi, xf, yf, thf: double; out v, w: double);
var
  tht, error_th, error_dist: double;
  distLine, testSideLine, nearX, nearY: double;
begin
  // Compute errors
  tht := arctan2(yf - yi, xf - xi);
  error_th := normalizeAngle(tht - th);
  error_dist := dist(xf - x, yf - y);
  distanceToLine(x, y, tht, xi, yi, xf, yf, distLine, testSideLine, nearX, nearY);

  // Transitions
  case state_followLine of
    FL_GO2INIT: begin                        // GO TO INITIAL POINT
      if (state_gotoXY = GO2XY_STOP) then begin
        state_followLine := FL_FOLLOWLINE;   //                     >>> FOLLOW LINE
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Go to initial point > Follow line');
        end;
      end;
    end;
    FL_NEWLINE: begin                        // NEW LINE (NEAREST POINT)
      if (state_gotoXY = GO2XY_STOP) then begin
        state_followLine := FL_FOLLOWLINE;   //                          >>> FOLLOW LINE
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Nearest point > Follow line');
        end;
      end;
    end;
    FL_FOLLOWLINE: begin                     // FOLLOW LINE
      if (error_dist < DIST_DEC) then begin
        state_followLine := FL_APPROACH;     //             >>> APPROACHING FINAL POINT
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Follow line > Approaching final point');
        end;
        state_gotoXY := GO2XY_FWDDEC;
      end else if (distLine > DIST_NEWPOSE) then begin
        state_followLine := FL_GO2INIT;      //             >>> GO TO INITIAL POINT
        state_gotoXY := GO2XY_ROTINI;
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Follow line > Go to initial point');
        end;
      end;
    end;
    FL_APPROACH: begin                       // APPROACHING FINAL POINT
      if (state_gotoXY = GO2XY_STOP) then begin
        state_followLine := FL_STOP;         //                         >>> STOP
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Approaching final point > Stop');
        end;
      end;
    end;
    FL_EMERGENCY: begin                      // EMERGENCY (SHORTEST PATH)
      if (state_gotoXY = GO2XY_STOP) then begin
        state_followLine := FL_STOP;         //                           >>> STOP
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Emergency > Stop');
        end;
      end;
    end;
    FL_STOP: begin                           // STOP
      if ((error_dist > DIST_NEWPOSE) or (abs(normalizeAngle(thf - th)) > TH_NEWPOSE)) then begin
        state_followLine := FL_GO2INIT;      //      >>> GO TO INITIAL POINT
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FL] Stop > Go to initial point');
        end;
        state_gotoXY := GO2XY_ROTINI;
      end;
    end;
  end;

  // Outputs
  case state_followLine of
    FL_GO2INIT: begin                        // GO TO INITIAL POINT
      gotoXY(x, y, th, xi, yi, tht, v, w);
    end;
    FL_NEWLINE: begin                        // NEW LINE (NEAREST POINT)
      gotoXY(x, y, th, nearX, nearY, tht, v, w);
    end;
    FL_FOLLOWLINE: begin                     // FOLLOW LINE
      v := V_NOM;
      w := (GAIN_DIST * testSideLine * distLine + GAIN_TH * error_th) * W_NOM;
    end;
    FL_APPROACH: begin                       // APPROACHING FINAL POINT
      gotoXY(x, y, th, xf, yf, thf, v, w);
    end;
    FL_EMERGENCY: begin                      // EMERGENCY (SHORTEST PATH)
      gotoXY(x, y, th, xf, yf, thf, v, w);
    end;
    FL_STOP: begin                           // STOP
      v := 0;
      w := 0;
      StopRobot;
    end;
  end;
end;





procedure TFMain.odometryCalibration(xodo,yodo,thodo: double; out v, w: double);
const
  // Machine state: index of the states
  CALIBRATION_INIT = 0;
  CALIBRATION_METHOD = 1;
  CALIBRATION_SAVEFILE = 2;
  // Common states of the paths implemented
  SM_METHOD_START = 1;
  SM_METHOD_STOP = 0;
var
  state_string: array [0..2] of string = ('Init', 'Method', 'Save file');
  string_method: string;
  deltaWh,deltaD,deltaTh: Double;
begin
  // Displacements
  deltaWh := pi*robot.D*robot.M1.deltaSteps/(2*STEPS_PER_180DEG[1]);
  deltaD  := deltaWh * cos(robot.M0.th + robot.ThOff);
  deltaTh := deltaWh * sin(robot.M0.th + robot.ThOff) / robot.L;
  deltaD_segment  := deltaD_segment  + Abs(deltaD);
  deltaTh_segment := deltaTh_segment + deltaTh;

  // Robot stopped
  robot_stopped := (robot.M1.deltaSteps = 0) AND (M0ActSpeed = 0);

  // Transitions
  case state_calibration of
    CALIBRATION_INIT:
    begin                               // INIT
      if (start_method) then
      begin
        state_calibration := CALIBRATION_METHOD;          //      >>> METHOD
        MmDebug.Clear;
        // Data file
        if (RbPathCircular.Checked) then
        begin
          string_method := 'circular';
          V_NOM_CIRC := V_NOM;
          V_DEC_CIRC := V_DEC;
          W_NOM_CIRC := V_NOM / StrToFloat(EdPath2.Text);
          W_DEC_CIRC := V_DEC / StrToFloat(EdPath2.Text);
        end
        else if (RbPathSquare.Checked) then
        begin
          string_method := 'square';
          // Set states for the GoToXY and FollowLine path algorithms
          state_followLine := FL_FOLLOWLINE;
        end
        else if (RbPathFree.Checked) then
        begin
          string_method := 'free';
        end;
        //AssignFile(tfDataOut, 'data/' + DateTimeToStr(Now) + '_' + string_method + '.txt');
        AssignFile(tfDataOut, 'data/' + string_method + '.txt');
        try
          Rewrite(tfDataOut);
        except
          on E: EInOutError do
          begin
            stop_method := True;
            Debug(MmDebug, '[ERROR] File handling.');
          end;
        end;
        if (not stop_method) then
        begin
          // Update datafile           
          writeln(tfDataOut, string_method);
          writeln(tfDataOut, format('%g,%g,%g,%d',[robot.L,robot.D,robot.ThOff,2*STEPS_PER_180DEG[1]]));
          writeln(tfDataOut, format('%g,%g,%g,%g',[StrToFloatDef(EdPath1.Text,0),StrToFloatDef(EdPath2.Text,0),StrToFloatDef(EdPath3.Text,0),StrToFloatDef(EdPath4.Text,0)]));
          writeln(tfDataOut, 'Run:,1');
          // Reset variables
          BtCalibrationStart.Enabled := False;
          BtCalibrationCheck.Enabled := False;
          if (RbPathFree.Checked) then begin
            BtCalibrationCheck.Enabled := True;
          end;
          finish_method := False;
          ResetOdometry;
          V_FREE := 0;
          W_FREE := 0;
          irun := 0;
          isegment := 0;
          istabilise := 0;
          deltaD_segment := 0;
          deltaTh_segment := 0;
          // Set method state
          state_method := SM_METHOD_START;
        end
        else
        begin
          BtCalibrationStart.Enabled := True;
          BtCalibrationCheck.Enabled := false;
        end;
        start_method := False;
        check_run := False;
      end;
    end;
    CALIBRATION_METHOD:
    begin                             // METHOD
      if (finish_method) then
      begin
        state_calibration := CALIBRATION_SAVEFILE;
        finish_method := False;
      end;
    end;
  end;

  // Stop condition
  if (stop_method) then
  begin
    if (state_calibration <> CALIBRATION_INIT) then
    begin
      CloseFile(tfDataOut);
      Debug(MmDebug, '[ERROR] Stop condition ACTIVATED!');
    end;
    state_calibration := CALIBRATION_SAVEFILE;
  end;

  // Outputs
  case state_calibration of
    CALIBRATION_INIT: begin                               // INIT
      ShState.Brush.Color := clGreen;
      // Stop robot
      v := 0;
      w := 0;
      StopRobot;
    end;
    CALIBRATION_METHOD: begin                             // METHOD
      ShState.Brush.Color := clRed;
      // Disable path fields
      RgPathType.Enabled := False;
      EdPath1.Enabled := False;
      EdPath2.Enabled := False;
      EdPath3.Enabled := False;
      EdPath4.Enabled := False;
      TsParameters.Enabled := False;
      // Method
      if (RbPathCircular.Checked) then
      begin
        followPathCircular(xodo, yodo, thodo, v, w);
      end
      else if (RbPathSquare.Checked) then
      begin
        followPathSquare(xodo, yodo, thodo, v, w);
      end else
      begin
        followPathFree(xodo, yodo, thodo, v, w);
      end;
    end;
    CALIBRATION_SAVEFILE: begin                           // SAVE FILE
      state_calibration := CALIBRATION_INIT;
      if (NOT stop_method) then
        CloseFile(tfDataOut);
      // Enable path fields
      RgPathType.Enabled := True;
      EdPath1.Enabled := True;
      EdPath2.Enabled := True;
      EdPath3.Enabled := True;
      EdPath4.Enabled := True;
      TsParameters.Enabled := True;
      // Reset variables
      ResetOdometry;
      V_FREE := 0;
      W_FREE := 0;
      irun := 0;
      isegment := 0;
      istabilise := 0;
      deltaD_segment := 0;
      deltaTh_segment := 0;
      start_method := False;
      stop_method := False;
      check_run := False;
      finish_method := False;
      // Enable buttons
      BtCalibrationStart.Enabled := True;
      BtCalibrationCheck.Enabled := False;
      // Stop robot
      v := 0;
      w := 0;
      StopRobot;
      UDP.SendMessage('P' + '00' + '01' + IntToHex(word(0), 4), EditUDPIP.Text + ':' + EditUDPSendPort.Text);
      UDP.SendMessage('S' + '01' + IntToHex(byte(255), 2) + IntToHex(word(0), 4), EditUDPIP.Text + ':' + EditUDPSendPort.Text);
    end;
  end;

  // Debug
  EdPrimaryState.Text := state_string[state_calibration];
end;

procedure TFMain.followPathCircular(xodo,yodo,thodo: double; out v, w: double);
const
  // Machine state: index of the states
  FOLLOWCIRCULAR_STOP = 0;
  FOLLOWCIRCULAR_ROT = 1;
  FOLLOWCIRCULAR_WAIT = 2;
  // Number of cycles to stabilise
  NUMCYCLESSTABILISE = 50;
var
  state_string: array [0..2] of string = ('Stop', 'Rotation', 'Waiting User');
begin
  // Save data
  if (((state_method = FOLLOWCIRCULAR_WAIT) or (state_method = FOLLOWCIRCULAR_STOP)) and
    (istabilise > NUMCYCLESSTABILISE) and (robot_stopped)) then
  begin
    writeln(tfDataOut, Format('%.3f,%d,%f,1', [globalTimeStamp,robot.M1.deltaSteps,robot.M0.th]));
  end
  else
  begin
    writeln(tfDataOut, Format('%.3f,%d,%.8f,0', [globalTimeStamp,robot.M1.deltaSteps,robot.M0.th]));
  end;

  // Transitions
  case state_method of
    FOLLOWCIRCULAR_ROT: begin                             // ROTATION
      if (abs(RadToDeg(deltaTh_segment)) >= 180 * StrToInt(EdPath4.Text)) then
      begin
        state_method := FOLLOWCIRCULAR_WAIT;              //          >>> WAITING USER INTERACTION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[CIRCULAR] Rotation > Waiting user interaction');
        end;
        // Reset accumulative displacements
        deltaD_segment := 0;
        deltaTh_segment := 0;
        // Update indexes
        irun := irun + 1;
        istabilise := 0;
        // Reset check run
        check_run := False;
        BtCalibrationCheck.Enabled := False;
        // Reset velocities
        V_NOM_CIRC := V_NOM;
        V_DEC_CIRC := V_DEC;
        W_NOM_CIRC := V_NOM / StrToFloat(EdPath2.Text);
        W_DEC_CIRC := V_DEC / StrToFloat(EdPath2.Text);
      end;
    end;
    FOLLOWCIRCULAR_WAIT: begin                            // WAITING USER INTERACTION
      if ((irun >= StrToInt(EdPath1.Text) * 2) and (istabilise >= NUMCYCLESSTABILISE) and
        (robot_stopped)) then begin
        state_method := FOLLOWCIRCULAR_STOP;              //                          >>> STOP
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[CIRCULAR] Waiting user interaction > Stop');
        end;
        Debug(MmDebug, 'Waiting data to stabilise...');
        // Update indexes
        irun := 0;
        isegment := 0;
        istabilise := 0;
        // Reset robot info
        ResetOdometry;
      end
      else if ((check_run) and (istabilise >= NUMCYCLESSTABILISE) and (robot_stopped)) then begin
        state_method := FOLLOWCIRCULAR_ROT;               //                          >>> ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[CIRCULAR] Waiting user interaction > Rotation');
        end;
        // Update indexes
        isegment := 0;
        istabilise := 0;
        // Reset check run
        BtCalibrationCheck.Enabled := False;
        check_run := False;
        // Reset robot info
        ResetOdometry;
        // Update date file
        writeln(tfDataOut, 'RUNFINISHED');
        writeln(tfDataOut, Format('Run:,%d', [irun + 1]));
      end;
    end;
    FOLLOWCIRCULAR_STOP:
    begin                                                 // STOP
      if (istabilise > NUMCYCLESSTABILISE) then
      begin
        finish_method := True;
        istabilise := 0;
        writeln(tfDataOut, 'METHODFINISHED');
        Debug(MmDebug, '!!!!! FINISH !!!!!');
      end;
    end;
  end;

  // Outputs
  case state_method of
    FOLLOWCIRCULAR_ROT: begin                             // ROTATION
      // Update velocities per 180º curves
      if (Floor(abs(RadToDeg(deltaTh_segment)) / 180) = isegment + 1) then
      begin
        isegment := isegment + 1;
        V_NOM_CIRC := StrToFloat(EdPath3.Text) * V_NOM_CIRC / 100;
        V_DEC_CIRC := StrToFloat(EdPath3.Text) * V_DEC_CIRC / 100;
      end;
      // Set velocities
      if (abs(RadToDeg(deltaTh_segment)) <= 180 * StrToInt(EdPath4.Text) - TH_DEC) then
      begin
        v := V_NOM_CIRC;
        if (irun < StrToInt(EdPath1.Text)) then
        begin
          w := -W_NOM_CIRC;
        end
        else
        begin
          w := W_NOM_CIRC;
        end;
      end
      else
      begin
        v := V_DEC_CIRC;
        if (irun < StrToInt(EdPath1.Text)) then
        begin
          w := -W_DEC_CIRC;
        end
        else
        begin
          w := W_DEC_CIRC;
        end;
      end;
    end;
    FOLLOWCIRCULAR_WAIT: begin                            // WAITING USER INTERACTION
      if ((not BtCalibrationCheck.Enabled) and (irun < StrToInt(EdPath1.Text) * 2) and
        (istabilise >= NUMCYCLESSTABILISE) and (robot_stopped)) then
      begin
        BtCalibrationCheck.Enabled := True;
      end;
      if (robot_stopped) then
      begin
        istabilise := istabilise + 1;
      end;
      // Change state
      ShState.Brush.Color := clYellow;
      // Stop motors
      v := 0;
      w := 0;
      StopRobot;
    end;
    FOLLOWCIRCULAR_STOP: begin                            // STOP
      if (robot_stopped) then
      begin
        istabilise := istabilise + 1;
      end;
      // Change state
      ShState.Brush.Color := clYellow;
      // Stop motors
      v := 0;
      w := 0;
      StopRobot;
    end;
  end;

  // Debug
  {if (CbDebug.Checked) then begin
    Debug(MmDebug,format('CR_V%.4fSQ_V%.4f',[v,w]));
  end;}
  EdMethodState.Text := state_string[state_method];
  EdRunIndex.Text := IntToStr(irun);
  EdSegmentIndex.Text := IntToStr(isegment);
end;

procedure TFMain.followPathSquare(xodo,yodo,thodo: double; out v, w: double);
const
  // Machine state: index of the states
  FOLLOWSQUARE_STOP = 0;
  FOLLOWSQUARE_LINE = 1;
  FOLLOWSQUARE_ROT = 2;
  FOLLOWSQUARE_WAIT = 3;
  // Number of cycles to stabilise
  NUMCYCLESSTABILISE = 50;
var
  state_string: array [0..3] of
  string = ('Stop', 'Straight-Line', '90º Rotation', 'Waiting User');
  xi, yi, xf, yf, thf: double;
begin
  // Save data
  if (((state_method = FOLLOWSQUARE_WAIT) or (state_method = FOLLOWSQUARE_STOP)) and
    (istabilise > NUMCYCLESSTABILISE) and (robot_stopped)) then
  begin
    writeln(tfDataOut, Format('%.3f,%d,%.8f,1', [globalTimeStamp,robot.M1.deltaSteps,robot.M0.th]));
  end
  else
  begin
    writeln(tfDataOut, Format('%.3f,%d,%.8f,0', [globalTimeStamp,robot.M1.deltaSteps,robot.M0.th]));
  end;

  // Transitions
  case state_method of
    FOLLOWSQUARE_LINE: begin                              // FOLLOW LINE
      if (state_followLine = FL_STOP) then begin
        state_method := FOLLOWSQUARE_ROT;                 //             >>> 90º ROTATION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[SQUARE] Follow Line > 90º Rotation');
        end;
        // Reset accumulative displacements
        deltaD_segment := 0;
        deltaTh_segment := 0;
        // Update indexes
        isegment := isegment + 1;
        // Set states for the GoToXY and FollowLine path algorithms
        state_gotoXY := GO2XY_ROTFIN;
      end;
    end;
    FOLLOWSQUARE_ROT: begin                               // 90º ROTATION
      if ((state_gotoXY = GO2XY_STOP) and (isegment < 4)) then
      begin
        state_method := FOLLOWSQUARE_LINE;                //              >>> FOLLOW LINE
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[SQUARE] 90º Rotation > Follow Line');
        end;
        // Reset accumulative displacements
        deltaD_segment := 0;
        deltaTh_segment := 0;
        // Set states for the GoToXY and FollowLine path algorithms
        state_followLine := FL_FOLLOWLINE;
      end
      else if ((state_gotoXY = GO2XY_STOP) and (isegment >= 4)) then begin
        state_method := FOLLOWSQUARE_WAIT;                //              >>> WAITING USER INTERACTION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[SQUARE] 90º Rotation > Waiting user interaction');
        end;
        // Reset accumulative displacements
        deltaD_segment := 0;
        deltaTh_segment := 0;
        // Update indexes
        irun := irun + 1;
        istabilise := 0;
        // Reset check run
        check_run := False;
        BtCalibrationCheck.Enabled := False;
        // Set states for the GoToXY and FollowLine path algorithms
        state_followLine := FL_FOLLOWLINE;
      end;
    end;
    FOLLOWSQUARE_WAIT: begin                              // WAITING USER INTERACTION
      if ((irun >= StrToInt(EdPath1.Text) * 2) and (istabilise >= NUMCYCLESSTABILISE) and
        (robot_stopped)) then begin
        state_method := FOLLOWSQUARE_STOP;                //                          >>> STOP
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[SQUARE] Waiting user interaction > Stop');
        end;
        Debug(MmDebug, 'Waiting data to stabilise...');
        // Update indexes
        irun := 0;
        isegment := 0;
        istabilise := 0;
        // Reset robot info
        ResetOdometry;
      end
      else if ((check_run) and (istabilise >= NUMCYCLESSTABILISE) and (robot_stopped)) then begin
        state_method := FOLLOWSQUARE_LINE;                //                          >>> FOLLOW LINE
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[SQUARE] 90º Rotation > Follow Line');
        end;
        // Update indexes
        isegment := 0;
        istabilise := 0;
        // Reset check run
        BtCalibrationCheck.Enabled := False;
        check_run := False;
        // Reset robot info
        ResetOdometry;
        // Update date file
        writeln(tfDataOut, 'RUNFINISHED');
        writeln(tfDataOut, Format('Run:,%d', [irun + 1]));
      end;
    end;
    FOLLOWSQUARE_STOP:
    begin
      if (istabilise > NUMCYCLESSTABILISE) then
      begin
        finish_method := True;
        istabilise := 0;
        writeln(tfDataOut, 'METHODFINISHED');
        Debug(MmDebug, '!!!!! FINISH !!!!!');
      end;
    end;
  end;

  // Outputs
  case state_method of
    FOLLOWSQUARE_LINE: begin                              // FOLLOW LINE
      if (irun < StrToInt(EdPath1.Text)) then
      begin
        case isegment of
          0:
          begin
            xi := 0;
            xf := StrToFloat(EdPath2.Text);
            yi := 0;
            yf := 0;
            thf := 0;
          end;
          1:
          begin
            xi := StrToFloat(EdPath2.Text);
            xf := StrToFloat(EdPath2.Text);
            yi := 0;
            yf := -StrToFloat(EdPath2.Text);
            thf := -pi / 2;
          end;
          2:
          begin
            xi := StrToFloat(EdPath2.Text);
            xf := 0;
            yi := -StrToFloat(EdPath2.Text);
            yf := -StrToFloat(EdPath2.Text);
            thf := -pi;
          end;
          3:
          begin
            xi := 0;
            xf := 0;
            yi := -StrToFloat(EdPath2.Text);
            yf := 0;
            thf := pi / 2;
          end;
        end;
      end
      else
      begin
        case isegment of
          0:
          begin
            xi := 0;
            xf := StrToFloat(EdPath2.Text);
            yi := 0;
            yf := 0;
            thf := 0;
          end;
          1:
          begin
            xi := StrToFloat(EdPath2.Text);
            xf := StrToFloat(EdPath2.Text);
            yi := 0;
            yf := StrToFloat(EdPath2.Text);
            thf := pi / 2;
          end;
          2:
          begin
            xi := StrToFloat(EdPath2.Text);
            xf := 0;
            yi := StrToFloat(EdPath2.Text);
            yf := StrToFloat(EdPath2.Text);
            thf := -pi;
          end;
          3:
          begin
            xi := 0;
            xf := 0;
            yi := StrToFloat(EdPath2.Text);
            yf := 0;
            thf := -pi / 2;
          end;
        end;
      end;
      followLine(xodo, yodo, thodo, xi, yi, xf, yf, thf, v, w);
    end;
    FOLLOWSQUARE_ROT: begin                               // 90º ROTATION
      if (irun < StrToInt(EdPath1.Text)) then
      begin
        case isegment of
          1:
          begin
            xf := StrToFloat(EdPath2.Text);
            yf := 0;
            thf := -pi / 2;
          end;
          2:
          begin
            xf := StrToFloat(EdPath2.Text);
            yf := -StrToFloat(EdPath2.Text);
            thf := -pi;
          end;
          3:
          begin
            xf := 0;
            yf := -StrToFloat(EdPath2.Text);
            thf := pi / 2;
          end;
          4:
          begin
            xf := 0;
            yf := 0;
            thf := 0;
          end;
        end;
      end
      else
      begin
        case isegment of
          1:
          begin
            xf := StrToFloat(EdPath2.Text);
            yf := 0;
            thf := pi / 2;
          end;
          2:
          begin
            xf := StrToFloat(EdPath2.Text);
            yf := StrToFloat(EdPath2.Text);
            thf := -pi;
          end;
          3:
          begin
            xf := 0;
            yf := StrToFloat(EdPath2.Text);
            thf := -pi / 2;
          end;
          4:
          begin
            xf := 0;
            yf := 0;
            thf := 0;
          end;
        end;
      end;
      gotoXY(xodo, yodo, thodo, xf, yf, thf, v, w);
    end;
    FOLLOWSQUARE_WAIT: begin                              // WAITING USER INTERACTION
      if ((not BtCalibrationCheck.Enabled) and (irun < StrToInt(EdPath1.Text) * 2) and
        (istabilise >= NUMCYCLESSTABILISE) and (robot_stopped)) then
      begin
        BtCalibrationCheck.Enabled := True;
      end;
      if (robot_stopped) then
      begin
        istabilise := istabilise + 1;
      end;
      // Change state
      ShState.Brush.Color := clYellow;
      // Stop motors
      v := 0;
      w := 0;
      StopRobot;
    end;
    FOLLOWSQUARE_STOP: begin                              // STOP
      if (robot_stopped) then
      begin
        istabilise := istabilise + 1;
      end;
      // Change state
      ShState.Brush.Color := clYellow;
      // Stop motors
      v := 0;
      w := 0;
      StopRobot;
    end;
  end;

  // Debug
  {if (CbDebug.Checked) then begin
    Debug(MmDebug,format('SQ_V%.4fSQ_V%.4f',[v,w]));
  end;}
  EdMethodState.Text := state_string[state_method];
  EdRunIndex.Text := IntToStr(irun);
  EdSegmentIndex.Text := IntToStr(isegment);
end;

procedure TFMain.followPathFree(xodo,yodo,thodo: double; out v, w: double);
const
  // Machine state: index of the states
  FOLLOWFREE_STOP = 0;
  FOLLOWFREE_RUN  = 1;
  FOLLOWFREE_WAIT = 2;
  // Number of cycles to stabilise
  NUMCYCLESSTABILISE = 50;
var
  state_string: array [0..2] of
  string = ('Stop', 'Free path', 'Waiting User');
begin
  // Save data
  if (((state_method = FOLLOWFREE_WAIT) or (state_method = FOLLOWFREE_STOP)) and
    (istabilise > NUMCYCLESSTABILISE) and (robot_stopped)) then
  begin
    writeln(tfDataOut, Format('%.3f,%d,%.8f,1', [globalTimeStamp,robot.M1.deltaSteps,robot.M0.th]));
  end
  else
  begin
    writeln(tfDataOut, Format('%.3f,%d,%.8f,0', [globalTimeStamp,robot.M1.deltaSteps,robot.M0.th]));
  end;

  // Transitions
  case state_method of
    FOLLOWFREE_RUN: begin                                 // FREE RUN
      if (check_run) then begin
        state_method := FOLLOWFREE_WAIT;                  //          >>> WAITING USER INTERACTION
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FREEPATH] Free run > Waiting user interaction');
        end;
        // Reset accumulative displacements
        deltaD_segment := 0;
        deltaTh_segment := 0;
        // Update indexes
        irun := irun + 1;
        istabilise := 0;
        // Reset check run
        check_run := False;
        BtCalibrationCheck.Enabled := False;
      end;
    end;
    FOLLOWFREE_WAIT: begin                                // WAITING USER INTERACTION
      if ((irun >= StrToInt(EdPath1.Text)) and (istabilise >= NUMCYCLESSTABILISE) and
        (robot_stopped)) then begin
        state_method := FOLLOWFREE_STOP;                  //                          >>> STOP
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FREEPATH] Waiting user interaction > Stop');
        end;
        Debug(MmDebug, 'Waiting data to stabilise...');
        // Update indexes
        irun := 0;
        isegment := 0;
        istabilise := 0;
        // Reset robot info
        ResetOdometry;
      end
      else if ((check_run) and (istabilise >= NUMCYCLESSTABILISE) and (robot_stopped)) then begin
        state_method := FOLLOWFREE_RUN;                   //                          >>> FREE RUN
        if (CbDebug.Checked) then begin
          Debug(MmDebug,'[FREEPATH] Waiting user interaction > Free run');
        end;
        // Update indexes
        isegment := 0;
        istabilise := 0;
        // Reset check run
        BtCalibrationCheck.Enabled := True;
        check_run := False;
        // Reset robot info
        ResetOdometry;
        // Update date file
        writeln(tfDataOut, 'RUNFINISHED');
        writeln(tfDataOut, Format('Run:,%d', [irun + 1]));
      end;
    end;
    FOLLOWFREE_STOP: begin                                // STOP
      if (istabilise > NUMCYCLESSTABILISE) then begin
        finish_method := True;
        istabilise := 0;
        writeln(tfDataOut, 'METHODFINISHED');
        Debug(MmDebug, '!!!!! FINISH !!!!!');
      end;
    end;
  end;

  // Outputs
  case state_method of
    FOLLOWFREE_RUN: begin                                 // FREE RUN
      v := V_FREE;
      w := W_FREE;
    end;
    FOLLOWFREE_WAIT: begin                                // WAITING USER INTERACTION
      if ((not BtCalibrationCheck.Enabled) and (irun < StrToInt(EdPath1.Text)) and
        (istabilise >= NUMCYCLESSTABILISE) and (robot_stopped)) then begin
        BtCalibrationCheck.Enabled := True;
      end;
      if (robot_stopped) then begin
        istabilise := istabilise + 1;
      end;
      // Change state
      ShState.Brush.Color := clYellow;
      // Stop motors
      v := 0;
      w := 0;
      StopRobot;
      V_FREE := 0;
      W_FREE := 0;
    end;
    FOLLOWFREE_STOP: begin                                // STOP
      if (robot_stopped) then begin
        istabilise := istabilise + 1;
      end;
      // Change state
      ShState.Brush.Color := clYellow;
      // Stop motors
      v := 0;
      w := 0;
      StopRobot;
      V_FREE := 0;
      W_FREE := 0;
    end;
  end;

  // Debug
  EdPath2.Text := format('%.4f',[V_FREE]);
  EdPath3.Text := format('%.4f',[W_FREE]);
  EdMethodState.Text := state_string[state_method];
  EdRunIndex.Text := IntToStr(irun);
  EdSegmentIndex.Text := IntToStr(0);
end;



end.

